From 5cafecc339c585699b064a5c57149f6d367d7c8b Mon Sep 17 00:00:00 2001
From: Didier Raboud <odyx@debian.org>
Date: Thu, 12 Apr 2012 14:13:35 +0200
Subject: [PATCH] In killproc(), make sure to exit 0 when the program is not running and when no signal was specified.

Closes: #668416
Reported-by: Peter Eisentraut <petere@debian.org>
Signed-off-by: Didier Raboud <odyx@debian.org>
---
 init-functions |    2 +-
 1 files changed, 1 insertions(+), 1 deletions(-)

diff --git a/init-functions b/init-functions
index 3be5648..9aa1db7 100644
--- a/init-functions
+++ b/init-functions
@@ -142,41 +142,41 @@ killproc () {
     sig=$(echo ${2:-} | sed -e 's/^-\(.*\)/\1/')
     sig=$(echo $sig | sed -e 's/^SIG\(.*\)/\1/')
     if [ "$sig" = 15 ] || [ "$sig" = TERM ]; then
         is_term_sig="terminate_signal"
     fi
     status=0
     if [ ! "$is_term_sig" ]; then
         if [ -n "$sig" ]; then
             /sbin/start-stop-daemon --stop --signal "$sig" \
 		--quiet $name_param || status="$?"
         else
             /sbin/start-stop-daemon --stop \
 		--retry 5 \
 		--quiet $name_param || status="$?"
         fi
     else
         /sbin/start-stop-daemon --stop --quiet \
 	    --oknodo $name_param || status="$?"
     fi
     if [ "$status" = 1 ]; then
-        if [ -n "$sig" ]; then
+        if [ -z "$sig" ]; then
             return 0
         fi
         return 3 # program is not running
     fi
 
     if [ "$status" = 0 ] && [ "$is_term_sig" ] && [ "$pidfile" ]; then
         pidofproc -p "$pidfile" "$1" >/dev/null || rm -f "$pidfile"
     fi
     return 0
 }
 
 # Return LSB status
 status_of_proc () {
     local pidfile daemon name status
 
     pidfile=
     OPTIND=1
     while getopts p: opt ; do
         case "$opt" in
             p)  pidfile="$OPTARG";;
-- 
1.7.2.5

